'****************************************************************
'*  Name    : NRF24l01+_mode_recever.BAS                                      *
'*  Author  : =MiX@$=                                           *
'*  Notice  : Copyright (c) 2014 =MiX@$=                        *
'*          : All Rights Reserved                               *
'*  Date    : 25.07.2014                                        *
'*  Version : 1.0                                               *
'*  Notes   :    !!!                                                 *
'*          :                                                   *
'****************************************************************
 '            PWR_UP, PRIM_RX   CE 
'  

 Device = 16F877A
 Xtal 20

' ================================ LCD ===============================================
                          
Declare LCD_Type ALPHA            '   - - 
Declare LCD_DTPin PORTB.4         '    
Declare LCD_ENPin PORTB.2         '   E 
Declare LCD_RSPin PORTB.3         '   RS 
Declare LCD_Interface 4           ' 4-      
Declare LCD_CommandUs 2000        '     
Declare LCD_DataUs 50             '     
Declare LCD_Lines 2               '    

TRISA = %00000010    
TRISB = %00000000
TRISC = %11111101
ADCON1 = %00000111

Clear PORTB
Clear PORTA
Symbol MO  = PORTB.0              ' MoSi
Symbol SCK = PORTB.1              ' 
Symbol NRF_CSN  = PORTA.0              ' Select slave 
Symbol MI  = PORTA.1              ' MiSo
Symbol NRF_CE  = PORTA.2              ' Chip enable
Symbol NRF_IRQ  = PORTC.0             ' 

Dim temp_byte As Byte
   
    Dim nrf_ptr As Byte                     ' array pointer
    Dim nrf_channel As Byte                 ' intialize with default value
    Dim nrf_address As Dword                ' Pipe 0 4 byte address - real address be read from EEPROM
    Dim nrf_rfsetup As Byte
    Dim nrf_setretr As Byte
    Dim nrf_errf As Byte                    ' error flgas
    Dim NRF_Status As Byte                  ' status byte
       
    Dim spi_array[16] As Byte               ' SPI transmit array
    Dim prom1 As Byte
    Dim prom2 As Byte
    Dim prom3 As Byte
    Dim i As Byte
    '
    Symbol W_REGISTER         = 0x20        ' Address 0 Write Register command
    Symbol R_REGISTER         = 0x00        ' Address 0 Read Register command
    Symbol R_RX_PAYLOAD       = 0x61        ' Read RX spi_array
    Symbol FLUSH_RX           = 0xE2        ' Flush RX FIFO
    Symbol REUSE_TX_PL        = 0xE3        ' Reuse last sent spi_array
    Symbol R_RX_PL_WID        = 0x60        ' read RX spi_array width for the top Rx spi_array in the FIFO

'==================================    
   Dim RH As Float
   Dim T  As Float
Symbol LED      = PORTC.1       ' LED 
Cls
Print At 1,1, "Recever"
DelayMS 500
Cls   
GoTo main                               ' 
 

'CS = 1 
'DelayMS 100
's = $21 
'CS = 0
'SHOut MO,SCK, MsbFirst, [s, $01]
'  SHIn MI,SCK, 0, [a]
'  CS = 1 
'Print At 1,1, "ADR:", Hex2 s, " ", Dec a, "  "
'DelayMS 5000
'CS = 1 
 'Init_RX:
'For s = 0 To 23
'CS = 0
'SHOut MO,SCK, MsbFirst, [s | 0]
'  SHIn MI,SCK, 0, [a]
'  CS = 1 
'Print At 1,1, "ADR:", Hex2 s, " ", Dec a, "  "
'DelayMS 5000
'Next
'GoTo Init_RX

SPI_READ:
NRF_CSN = 0
        SHOut MO,SCK, MsbFirst, [spi_array[0]]
              SHIn MI,SCK, 0, [spi_array[1]]
NRF_CSN = 1
Return

SPI_READ2:
NRF_CSN = 0
        SHOut MO,SCK, MsbFirst, [spi_array[0]]
              SHIn MI,SCK, 0, [spi_array[1],spi_array[2]]
NRF_CSN = 1
Return

SPI_READ4:
NRF_CSN = 0
        SHOut MO,SCK, MsbFirst, [spi_array[0]]
              SHIn MI,SCK, 0, [spi_array[1],spi_array[2],spi_array[3],spi_array[4]]
NRF_CSN = 1
Return

SPI_READ8:
NRF_CSN = 0
        SHOut MO,SCK, MsbFirst, [spi_array[0]]
              SHIn MI,SCK, 0, [spi_array[1],spi_array[2],spi_array[3],spi_array[4],spi_array[5],spi_array[6],spi_array[7],spi_array[8]]
NRF_CSN = 1
Return

Check_SPI:
NRF_CSN = 0
        prom3 = spi_array[0]
              ClearBit prom3, 5
SHOut MO,SCK, MsbFirst, [prom3]
      SHIn MI,SCK, 0, [prom2]
NRF_CSN = 1
  If prom2 != prom1 Then Cls : Print At 1,1, Hex2 prom3, "-Bad register " : Print At 2,1, "Out: ",Hex2 prom1,"   In: ", Hex2 prom2 : Stop
Return

Check_SPI4:
NRF_CSN = 0
        prom3 = spi_array[0]
              ClearBit prom3, 5
SHOut MO,SCK, MsbFirst, [prom3]
      SHIn MI,SCK, 0, [spi_array[10],spi_array[11],spi_array[12],spi_array[13]]
NRF_CSN = 1
  If prom2 != prom1 Then Cls : Print At 1,1, Hex2 prom3, "-Bad register " : Print At 2,1, Hex2 spi_array[10],Hex2 spi_array[11],Hex2 spi_array[12],Hex2 spi_array[13] : Stop
Return

Load_NRF:
    nrf_channel = 0x02                      ' Channel #2
    nrf_address = 0xCFE7E7CF                ' some address
    nrf_rfsetup = 0x26                      ' 00100110 => 250kbps, 0dBm 
    nrf_setretr = 0x38                      ' 00100100 => ARD = 1000uS, ARC = 8 
Return
    
 
'
'---[SPI sub for the NRF24L01+]-------------
SPI_NRF: 
NRF_CSN = 0      
    SHOut MO,SCK, MsbFirst, [spi_array[0]]
NRF_CSN = 1               
Return  
    
SPI_NRF2:
NRF_CSN = 0 
SHOut MO,SCK, MsbFirst, [spi_array[0],spi_array[1]]
NRF_CSN = 1               
Return    

'=========================================
SPI_NRF4: 
NRF_CSN = 0
SHOut MO,SCK, MsbFirst, [spi_array[0],spi_array[1],spi_array[2],spi_array[3],spi_array[4]]
NRF_CSN = 1              
Return

Init_PRX:
    NRF_CE = 0                              ' standby mode
'----------------------------------------    
'REG 00 CONFIG    
                          
    spi_array[0] = W_REGISTER               ' W_REGISTER at address $00 => CONFIG
    spi_array[1] = 0x39                     ' PRX, CRC enabled
    prom1 = spi_array[1] 
    nrf_ptr = 1
    GoSub SPI_NRF2
    
    GoSub Check_SPI
'----------------------------------------    
'REG 01 EN_AA    
      
    spi_array[0] = W_REGISTER | 0x01        ' W_REGISTER at address $01 => EN_AA
    spi_array[1] = 0x01                     ' enable auto-ack only for pipe 0
    prom1 = spi_array[1] 
    nrf_ptr = 1
    GoSub SPI_NRF2
   
    GoSub Check_SPI
'----------------------------------------    
'REG 02 EN_RXADDR    
    
    spi_array[0] = W_REGISTER | 0x02        ' W_REGISTER at address $02 => EN_RXADDR
    spi_array[1] = 0x01                     ' enable only pipe 0 
    prom1 = spi_array[1]
    nrf_ptr = 1
    GoSub SPI_NRF2
    
    GoSub Check_SPI
'----------------------------------------    
'REG 03 SETUP AW     
    
    spi_array[0] = W_REGISTER | 0x03        ' W_REGISTER at address $03 => SETUP AW
    spi_array[1] = 0x02                     ' address width = 4 bytes
    prom1 = spi_array[1]
    nrf_ptr = 1
    GoSub SPI_NRF2
    
    GoSub Check_SPI
'---------------------------------------- 
'REG 05 RF_CH   
    
    spi_array[0] = W_REGISTER | 0x05        ' W_REGISTER at address $05 => RF_CH
    spi_array[1] = nrf_channel              ' set channel to variable  
    prom1 = spi_array[1]
    nrf_ptr = 1
    GoSub SPI_NRF2
    
    GoSub Check_SPI
'----------------------------------------   
'REG 06 RF_SETUP                            ' note - reduce power and increase speed in final app
    
    spi_array[0] = W_REGISTER | 0x06        ' W_REGISTER at address $06 => RF_SETUP
    spi_array[1] = nrf_rfsetup              ' 0x02 = DR = 1Mbps, RF_POWER -12dBm, 0x26 = DR = 250kbps, RF_POWER 0dBm
    prom1 = spi_array[1]
    nrf_ptr = 1
    GoSub SPI_NRF2
    
    GoSub Check_SPI
'----------------------------------------    
'REG 07 STATUS   
    
    spi_array[0] = W_REGISTER | 0x07        ' W_REGISTER at address $27 => STATUS
    spi_array[1] = 0x7E                     ' Clear Interrupts
    
    nrf_ptr = 1
    GoSub SPI_NRF2
      
      
'----------------------------------------             
'REG 0A RX_ADDR_P0           
    
    spi_array[0] = W_REGISTER | 0x0A        ' W_REGISTER at address $0A => RX_ADDR_P0
    spi_array[1] = nrf_address.Byte0        ' RX address byte 0 LSByte
    spi_array[2] = nrf_address.Byte1        ' RX address byte 1
    spi_array[3] = nrf_address.Byte2        ' RX address byte 2
    spi_array[4] = nrf_address.Byte3        ' RX address byte 3
    nrf_ptr = 4
    GoSub SPI_NRF4
    
    
    GoSub Check_SPI4
    
    
'---------------------------------------- 
'REG 11 RX_PW_PO    
    
    spi_array[0] = W_REGISTER | 0x11        ' W_REGISTER at address $11 => RX_PW_PO
    spi_array[1] = 0x04                     ' 4 byte payload width on Pipe0
    prom1 = spi_array[1]
    nrf_ptr = 1
    GoSub SPI_NRF2
    
    GoSub Check_SPI
'----------------------------------------         
'REG 0x1C DYNPD    
    
    spi_array[0] = W_REGISTER | 0x1C        ' W_REGISTER at address $1C => DYNPD (Dynamic Payload)
    spi_array[1] = 0x01                     ' enable dynamic payload on Pipe0
    prom1 = spi_array[1]
    nrf_ptr = 1
    GoSub SPI_NRF2
    
    GoSub Check_SPI
'----------------------------------------        
    ;REG 0x1D FEATURE    
    
    spi_array[0] = W_REGISTER | 0x1D        ' W_REGISTER at address $1D => FEATURE
    spi_array[1] = 0x04                     ' set bit 2 (EN_DPL) to enable dynamic payload. 
    prom1 = spi_array[1]  
    nrf_ptr = 1
    GoSub SPI_NRF2
    
    GoSub Check_SPI
'----------------------------------------               
'REG 00 CONFIG     
    
    spi_array[0] = W_REGISTER               ' W_REGISTER at address $00 => CONFIG
    spi_array[1] = 0x3B                     ' PRX, PWR_UP = 1,CRC = 1 byte, CRC enable, RX_DR INT 
    prom1 = spi_array[1]
    nrf_ptr = 1
    GoSub SPI_NRF2
    
    GoSub Check_SPI
    Print At 1,1, "Init ok!"
    DelayMS 2000                            ' Critical! min 1500uS Tpd2stby delay 
    Cls
    Return
'=========================================
'
RX_DPL_LEN:
    
    spi_array[0] = R_RX_PL_WID              ' Read Rx payload length
    nrf_ptr = 1                             ' index of 2 bytes
    GoSub SPI_READ
    
    nrf_ptr = spi_array[1]                  ' the payload length is returned and can be used to determine hthe number of data bytes
    
    If nrf_ptr > 0x20 Then                  ' max length = 32 byte so error
        nrf_ptr = 0
        nrf_errf = 1
        Clear spi_array
        GoSub FLUSH_RX_FIFO
        Return
    EndIf
    Return
'
RX_RECIEVE:
    nrf_errf = 0
    GoSub RX_DPL_LEN                        ' get the dynamic payload length
    If nrf_errf = 1 Then Return             ' return error from dynamic payload length
   
    Clear spi_array                         
    spi_array[0] = R_RX_PAYLOAD             ' Read Rx payload command
    GoSub SPI_READ8
    
    Return
'
READ_NRF_STATUS:                            ' read STATUS for Interrupt source 
    spi_array[0] = R_REGISTER | 0x07        ' Read Register $07 => STATUS
    nrf_ptr = 0
    
    GoSub SPI_READ  
        
    NRF_Status = spi_array[1]               ' bit6=RX_DR, bit5 = TX_DS, bit4 = MAX_RT          
    Return
'
CLR_NRF_INT:                                ' Clear Interrupts   
    spi_array[0] = W_REGISTER | 0x07        ' W_REGISTER at address $07 => STATUS
    spi_array[1] = 0x70                     ' Clear all Interrupts
    nrf_ptr = 1
    
    GoSub SPI_NRF2  
        
    Return
'    
FLUSH_RX_FIFO:                              ' flush all RX FIFO slots   
    spi_array[0] = FLUSH_RX
    nrf_ptr = 0
    
    GoSub SPI_NRF
         
    Return
'
NRF_RX_READY:
    GoSub FLUSH_RX_FIFO  
    
    Clear spi_array
    NRF_CE = 1                              ' Active Rx mode
    DelayUS 150                             ' min 130uS RX settle delay
    Return

main:     
    High NRF_CSN                            ' unselect the NRF tranciver
    Low NRF_CE                              ' clear NRF_CE until we start working
    Low LED
    DelayMS 200
    GoSub Load_NRF
    GoSub Init_PRX            
    GoSub NRF_RX_READY                      ' activate as RX using standard values
    '
    
    While 1 = 1
           
    
        If NRF_IRQ = 0 Then     
            GoSub READ_NRF_STATUS
                ' Print At 1,1, Hex2 NRF_Status, "     "
            GoSub CLR_NRF_INT               ' Clear NRF Interrupts from Status reg
            
            If NRF_Status.6 = 1 Then        ' Status.6 = RX_DR   
                GoSub RX_RECIEVE            ' get the payload                                    
                If nrf_errf = 0 Then                
                   ' LED = spi_array[1] - 0x30   ' ignor spi_array[0] it has garbage from the command, "0" = 0x30, "1" = 0x31        
                     RH.Byte0 = spi_array[1]
                     RH.Byte1 = spi_array[2]
                     RH.Byte2 = spi_array[3]
                     RH.Byte3 = spi_array[4]
                     
                     T.Byte0 = spi_array[5]
                     T.Byte1 = spi_array[6]
                     T.Byte2 = spi_array[7]
                     T.Byte3 = spi_array[8]
                     
                     Print At 1,1,  "RH         "," T    " 
                     Print At 2,1,  Dec2 RH,"%  " , Dec2 T, 223, "C "
                     PulseOut LED, 60000
                     'DelayMS 1000
                     'Cls
                EndIf                                
            EndIf   
            GoSub NRF_RX_READY  
        EndIf
    Wend

